Class ImagesClient (1.88.0)

GitHub RepositoryProduct Reference

Service Description: The Images API.

This class provides the ability to make remote calls to the backing service through method calls that map to API methods. Sample code to get started:


 // This snippet has been automatically generated and should be regarded as a code template only.
 // It will require modifications to work:
 // - It may require correct/in-range values for request initialization.
 // - It may require specifying regional endpoints when creating the service client as shown in
 // https://cloud.google.com/java/docs/setup#configure_endpoints_for_the_client_library
 try (ImagesClient imagesClient = ImagesClient.create()) {
   String project = "project-309310695";
   String image = "image100313435";
   Image response = imagesClient.get(project, image);
 }
 

Note: close() needs to be called on the ImagesClient object to clean up resources such as threads. In the example above, try-with-resources is used, which automatically calls close().

Methods
Method Description Method Variants

Delete

Deletes the specified image.

Request object method variants only take one parameter, a request object, which must be constructed before the call.

  • deleteAsync(DeleteImageRequest request)

Methods that return long-running operations have "Async" method variants that return OperationFuture, which is used to track polling of the service.

  • deleteAsync(String project, String image)

Callable method variants take no parameters and return an immutable API callable object, which can be used to initiate calls to the service.

  • deleteOperationCallable()

  • deleteCallable()

Deprecate

Sets the deprecation status of an image. If an empty request body is given, clears the deprecation status instead.

Request object method variants only take one parameter, a request object, which must be constructed before the call.

  • deprecateAsync(DeprecateImageRequest request)

Methods that return long-running operations have "Async" method variants that return OperationFuture, which is used to track polling of the service.

  • deprecateAsync(String project, String image, DeprecationStatus deprecationStatusResource)

Callable method variants take no parameters and return an immutable API callable object, which can be used to initiate calls to the service.

  • deprecateOperationCallable()

  • deprecateCallable()

Get

Returns the specified image.

Request object method variants only take one parameter, a request object, which must be constructed before the call.

  • get(GetImageRequest request)

"Flattened" method variants have converted the fields of the request object into function parameters to enable multiple ways to call the same method.

  • get(String project, String image)

Callable method variants take no parameters and return an immutable API callable object, which can be used to initiate calls to the service.

  • getCallable()

GetFromFamily

Returns the latest image that is part of an image family and is not deprecated. For more information on image families, see Public image families documentation.

Request object method variants only take one parameter, a request object, which must be constructed before the call.

  • getFromFamily(GetFromFamilyImageRequest request)

"Flattened" method variants have converted the fields of the request object into function parameters to enable multiple ways to call the same method.

  • getFromFamily(String project, String family)

Callable method variants take no parameters and return an immutable API callable object, which can be used to initiate calls to the service.

  • getFromFamilyCallable()

GetIamPolicy

Gets the access control policy for a resource. May be empty if no such policy or resource exists.

Request object method variants only take one parameter, a request object, which must be constructed before the call.

  • getIamPolicy(GetIamPolicyImageRequest request)

"Flattened" method variants have converted the fields of the request object into function parameters to enable multiple ways to call the same method.

  • getIamPolicy(String project, String resource)

Callable method variants take no parameters and return an immutable API callable object, which can be used to initiate calls to the service.

  • getIamPolicyCallable()

Insert

Creates an image in the specified project using the data included in the request.

Request object method variants only take one parameter, a request object, which must be constructed before the call.

  • insertAsync(InsertImageRequest request)

Methods that return long-running operations have "Async" method variants that return OperationFuture, which is used to track polling of the service.

  • insertAsync(String project, Image imageResource)

Callable method variants take no parameters and return an immutable API callable object, which can be used to initiate calls to the service.

  • insertOperationCallable()

  • insertCallable()

List

Retrieves the list of custom images available to the specified project. Custom images are images you create that belong to your project. This method does not get any images that belong to other projects, including publicly-available images, like Debian 8. If you want to get a list of publicly-available images, use this method to make a request to the respective image project, such as debian-cloud or windows-cloud.

Request object method variants only take one parameter, a request object, which must be constructed before the call.

  • list(ListImagesRequest request)

"Flattened" method variants have converted the fields of the request object into function parameters to enable multiple ways to call the same method.

  • list(String project)

Callable method variants take no parameters and return an immutable API callable object, which can be used to initiate calls to the service.

  • listPagedCallable()

  • listCallable()

Patch

Patches the specified image with the data included in the request. Only the following fields can be modified: family, description, deprecation status.

Request object method variants only take one parameter, a request object, which must be constructed before the call.

  • patchAsync(PatchImageRequest request)

Methods that return long-running operations have "Async" method variants that return OperationFuture, which is used to track polling of the service.

  • patchAsync(String project, String image, Image imageResource)

Callable method variants take no parameters and return an immutable API callable object, which can be used to initiate calls to the service.

  • patchOperationCallable()

  • patchCallable()

SetIamPolicy

Sets the access control policy on the specified resource. Replaces any existing policy.

Request object method variants only take one parameter, a request object, which must be constructed before the call.

  • setIamPolicy(SetIamPolicyImageRequest request)

"Flattened" method variants have converted the fields of the request object into function parameters to enable multiple ways to call the same method.

  • setIamPolicy(String project, String resource, GlobalSetPolicyRequest globalSetPolicyRequestResource)

Callable method variants take no parameters and return an immutable API callable object, which can be used to initiate calls to the service.

  • setIamPolicyCallable()

SetLabels

Sets the labels on an image. To learn more about labels, read the Labeling Resources documentation.

Request object method variants only take one parameter, a request object, which must be constructed before the call.

  • setLabelsAsync(SetLabelsImageRequest request)

Methods that return long-running operations have "Async" method variants that return OperationFuture, which is used to track polling of the service.

  • setLabelsAsync(String project, String resource, GlobalSetLabelsRequest globalSetLabelsRequestResource)

Callable method variants take no parameters and return an immutable API callable object, which can be used to initiate calls to the service.

  • setLabelsOperationCallable()

  • setLabelsCallable()

TestIamPermissions

Returns permissions that a caller has on the specified resource.

Request object method variants only take one parameter, a request object, which must be constructed before the call.

  • testIamPermissions(TestIamPermissionsImageRequest request)

"Flattened" method variants have converted the fields of the request object into function parameters to enable multiple ways to call the same method.

  • testIamPermissions(String project, String resource, TestPermissionsRequest testPermissionsRequestResource)

Callable method variants take no parameters and return an immutable API callable object, which can be used to initiate calls to the service.

  • testIamPermissionsCallable()

See the individual methods for example code.

Many parameters require resource names to be formatted in a particular way. To assist with these names, this class includes a format method for each type of name, and additionally a parse method to extract the individual identifiers contained within names that are returned.

This class can be customized by passing in a custom instance of ImagesSettings to create(). For example:

To customize credentials:


 // This snippet has been automatically generated and should be regarded as a code template only.
 // It will require modifications to work:
 // - It may require correct/in-range values for request initialization.
 // - It may require specifying regional endpoints when creating the service client as shown in
 // https://cloud.google.com/java/docs/setup#configure_endpoints_for_the_client_library
 ImagesSettings imagesSettings =
     ImagesSettings.newBuilder()
         .setCredentialsProvider(FixedCredentialsProvider.create(myCredentials))
         .build();
 ImagesClient imagesClient = ImagesClient.create(imagesSettings);
 

To customize the endpoint:


 // This snippet has been automatically generated and should be regarded as a code template only.
 // It will require modifications to work:
 // - It may require correct/in-range values for request initialization.
 // - It may require specifying regional endpoints when creating the service client as shown in
 // https://cloud.google.com/java/docs/setup#configure_endpoints_for_the_client_library
 ImagesSettings imagesSettings = ImagesSettings.newBuilder().setEndpoint(myEndpoint).build();
 ImagesClient imagesClient = ImagesClient.create(imagesSettings);
 

Please refer to the GitHub repository's samples for more quickstart code snippets.

Inheritance

java.lang.Object > ImagesClient

Static Methods

create()

public static final ImagesClient create()

Constructs an instance of ImagesClient with default settings.

Returns
Type Description
ImagesClient
Exceptions
Type Description
IOException

create(ImagesSettings settings)

public static final ImagesClient create(ImagesSettings settings)

Constructs an instance of ImagesClient, using the given settings. The channels are created based on the settings passed in, or defaults for any settings that are not set.

Parameter
Name Description
settings ImagesSettings
Returns
Type Description
ImagesClient
Exceptions
Type Description
IOException

create(ImagesStub stub)

public static final ImagesClient create(ImagesStub stub)

Constructs an instance of ImagesClient, using the given stub for making calls. This is for advanced usage - prefer using create(ImagesSettings).

Parameter
Name Description
stub ImagesStub
Returns
Type Description
ImagesClient

Constructors

ImagesClient(ImagesSettings settings)

protected ImagesClient(ImagesSettings settings)

Constructs an instance of ImagesClient, using the given settings. This is protected so that it is easy to make a subclass, but otherwise, the static factory methods should be preferred.

Parameter
Name Description
settings ImagesSettings

ImagesClient(ImagesStub stub)

protected ImagesClient(ImagesStub stub)
Parameter
Name Description
stub ImagesStub

Methods

awaitTermination(long duration, TimeUnit unit)

public boolean awaitTermination(long duration, TimeUnit unit)
Parameters
Name Description
duration long
unit TimeUnit
Returns
Type Description
boolean
Exceptions
Type Description
InterruptedException

close()

public final void close()

deleteAsync(DeleteImageRequest request)

public final OperationFuture<Operation,Operation> deleteAsync(DeleteImageRequest request)

Deletes the specified image.

Sample code:


 // This snippet has been automatically generated and should be regarded as a code template only.
 // It will require modifications to work:
 // - It may require correct/in-range values for request initialization.
 // - It may require specifying regional endpoints when creating the service client as shown in
 // https://cloud.google.com/java/docs/setup#configure_endpoints_for_the_client_library
 try (ImagesClient imagesClient = ImagesClient.create()) {
   DeleteImageRequest request =
       DeleteImageRequest.newBuilder()
           .setImage("image100313435")
           .setProject("project-309310695")
           .setRequestId("requestId693933066")
           .build();
   Operation response = imagesClient.deleteAsync(request).get();
 }
 
Parameter
Name Description
request DeleteImageRequest

The request object containing all of the parameters for the API call.

Returns
Type Description
OperationFuture<Operation,Operation>

deleteAsync(String project, String image)

public final OperationFuture<Operation,Operation> deleteAsync(String project, String image)

Deletes the specified image.

Sample code:


 // This snippet has been automatically generated and should be regarded as a code template only.
 // It will require modifications to work:
 // - It may require correct/in-range values for request initialization.
 // - It may require specifying regional endpoints when creating the service client as shown in
 // https://cloud.google.com/java/docs/setup#configure_endpoints_for_the_client_library
 try (ImagesClient imagesClient = ImagesClient.create()) {
   String project = "project-309310695";
   String image = "image100313435";
   Operation response = imagesClient.deleteAsync(project, image).get();
 }
 
Parameters
Name Description
project String

Project ID for this request.

image String

Name of the image resource to delete.

Returns
Type Description
OperationFuture<Operation,Operation>

deleteCallable()

public final UnaryCallable<DeleteImageRequest,Operation> deleteCallable()

Deletes the specified image.

Sample code:


 // This snippet has been automatically generated and should be regarded as a code template only.
 // It will require modifications to work:
 // - It may require correct/in-range values for request initialization.
 // - It may require specifying regional endpoints when creating the service client as shown in
 // https://cloud.google.com/java/docs/setup#configure_endpoints_for_the_client_library
 try (ImagesClient imagesClient = ImagesClient.create()) {
   DeleteImageRequest request =
       DeleteImageRequest.newBuilder()
           .setImage("image100313435")
           .setProject("project-309310695")
           .setRequestId("requestId693933066")
           .build();
   ApiFuture<Operation> future = imagesClient.deleteCallable().futureCall(request);
   // Do something.
   Operation response = future.get();
 }
 
Returns
Type Description
UnaryCallable<DeleteImageRequest,Operation>

deleteOperationCallable()

public final OperationCallable<DeleteImageRequest,Operation,Operation> deleteOperationCallable()

Deletes the specified image.

Sample code:


 // This snippet has been automatically generated and should be regarded as a code template only.
 // It will require modifications to work:
 // - It may require correct/in-range values for request initialization.
 // - It may require specifying regional endpoints when creating the service client as shown in
 // https://cloud.google.com/java/docs/setup#configure_endpoints_for_the_client_library
 try (ImagesClient imagesClient = ImagesClient.create()) {
   DeleteImageRequest request =
       DeleteImageRequest.newBuilder()
           .setImage("image100313435")
           .setProject("project-309310695")
           .setRequestId("requestId693933066")
           .build();
   OperationFuture<Operation, Operation> future =
       imagesClient.deleteOperationCallable().futureCall(request);
   // Do something.
   Operation response = future.get();
 }
 
Returns
Type Description
OperationCallable<DeleteImageRequest,Operation,Operation>

deprecateAsync(DeprecateImageRequest request)

public final OperationFuture<Operation,Operation> deprecateAsync(DeprecateImageRequest request)

Sets the deprecation status of an image. If an empty request body is given, clears the deprecation status instead.

Sample code:


 // This snippet has been automatically generated and should be regarded as a code template only.
 // It will require modifications to work:
 // - It may require correct/in-range values for request initialization.
 // - It may require specifying regional endpoints when creating the service client as shown in
 // https://cloud.google.com/java/docs/setup#configure_endpoints_for_the_client_library
 try (ImagesClient imagesClient = ImagesClient.create()) {
   DeprecateImageRequest request =
       DeprecateImageRequest.newBuilder()
           .setDeprecationStatusResource(DeprecationStatus.newBuilder().build())
           .setImage("image100313435")
           .setProject("project-309310695")
           .setRequestId("requestId693933066")
           .build();
   Operation response = imagesClient.deprecateAsync(request).get();
 }
 
Parameter
Name Description
request DeprecateImageRequest

The request object containing all of the parameters for the API call.

Returns
Type Description
OperationFuture<Operation,Operation>

deprecateAsync(String project, String image, DeprecationStatus deprecationStatusResource)

public final OperationFuture<Operation,Operation> deprecateAsync(String project, String image, DeprecationStatus deprecationStatusResource)

Sets the deprecation status of an image. If an empty request body is given, clears the deprecation status instead.

Sample code:


 // This snippet has been automatically generated and should be regarded as a code template only.
 // It will require modifications to work:
 // - It may require correct/in-range values for request initialization.
 // - It may require specifying regional endpoints when creating the service client as shown in
 // https://cloud.google.com/java/docs/setup#configure_endpoints_for_the_client_library
 try (ImagesClient imagesClient = ImagesClient.create()) {
   String project = "project-309310695";
   String image = "image100313435";
   DeprecationStatus deprecationStatusResource = DeprecationStatus.newBuilder().build();
   Operation response =
       imagesClient.deprecateAsync(project, image, deprecationStatusResource).get();
 }
 
Parameters
Name Description
project String

Project ID for this request.

image String

Image name.

deprecationStatusResource DeprecationStatus

The body resource for this request

Returns
Type Description
OperationFuture<Operation,Operation>

deprecateCallable()

public final UnaryCallable<DeprecateImageRequest,Operation> deprecateCallable()

Sets the deprecation status of an image. If an empty request body is given, clears the deprecation status instead.

Sample code:


 // This snippet has been automatically generated and should be regarded as a code template only.
 // It will require modifications to work:
 // - It may require correct/in-range values for request initialization.
 // - It may require specifying regional endpoints when creating the service client as shown in
 // https://cloud.google.com/java/docs/setup#configure_endpoints_for_the_client_library
 try (ImagesClient imagesClient = ImagesClient.create()) {
   DeprecateImageRequest request =
       DeprecateImageRequest.newBuilder()
           .setDeprecationStatusResource(DeprecationStatus.newBuilder().build())
           .setImage("image100313435")
           .setProject("project-309310695")
           .setRequestId("requestId693933066")
           .build();
   ApiFuture<Operation> future = imagesClient.deprecateCallable().futureCall(request);
   // Do something.
   Operation response = future.get();
 }
 
Returns
Type Description
UnaryCallable<DeprecateImageRequest,Operation>